jQuery(document).ready(function($){
	plugsN = $('.eos-dp-plugin-name').length;
	eos_dpBody = $('body');
	right = eos_dp_js.is_rtl ? 'left' : 'right';
	psiButtons = $('.eos-dp-psi-preview');


	$('.eos-dp-lock-post-wrp').on('click',function(event){
		$('#eos-dp-plugins-wrp').toggleClass('eos-post-locked');
		$(this).parent().toggleClass('eos-post-locked');
		if($(this).parent().hasClass('eos-post-locked')){
			$('#eos-dp-plugins-wrp').addClass('eos-post-locked');
			$('#eos_dp_single_locked').val('locked');
			$('#eos-dp-post-types-override').addClass('eos-hidden');
		}
		else{
			$('#eos-dp-plugins-wrp').removeClass('eos-post-locked');
			$('#eos_dp_single_locked').val('unlocked');
			$.ajax({
				type : "POST",
				url : ajaxurl,
				data : {
						"nonce" : $("#eos_dp_setts").val(),
						"post_type" : eos_dp_js.post_type,
						"action" : 'eos_dp_check_single_padlock'
					},
				success : function (response) {
					if ('override' === response) {
						$('#eos-dp-post-types-override').removeClass('eos-hidden');
					}

				}
			});			
		}
	});
	$('.eos-dp-preview').on('click',function(event){
		var a = this,
			plugin_path = '',
			theme = $('.eos-dp-themes-list').val(),
			chk;
		$('.eos-fdp-checkbox').each(function(){
			chk = $(this);
			if(chk.is(':checked') && !chk.hasClass('eos-dp-global-chk-row')){
				var data_path = chk.val();
				if('undefined' !== data_path){
					plugin_path += ';pn:' + data_path;
				}
			}
			else{
				plugin_path += ';pn:';
			}
		});
		var button = $(this),
			page_speed_insights = button.attr('data-page_speed_insights'),
			admin = 'undefined' !== typeof(eos_dp_js.page && 'eos_dp_admin' === eos_dp_js.page) ? '_admin' : '',
			data = {
				"nonce" : $("#eos_dp_setts").val(),
				"post_id" : eos_dp_js.post_id,
				"plugin_path" : plugin_path,
				"page_speed_insights" : page_speed_insights,
				"action" : 'eos_dp_preview'
			};
		eos_dpBody.addClass('eos-test-in-progress');
		$.ajax({
			type : "POST",
			url : ajaxurl,
			data : data,
			success : function (response) {
				if (parseInt(response) == 1) {
					var first_href = a.href,
						theme_arg = '',
						encode_url = 'undefined' !== typeof(a.dataset.encode_url) && 'true' === a.dataset.encode_url;

					if('dummy_html' !== theme){
						theme_arg = encode_url ? '%26theme%3D' + theme : '&theme=' + theme;
						a.href = a.href.split('%26theme%3D')[0].replace('&','%26') + '%26theme%3D' + theme;
					}
					else{
						a.href = a.href.split('=http')[0].split('%3Dhttp')[0] + '=' + eos_dp_js.html_url;
					}
					
					if(encode_url){
						a.href = a.href.split('%26theme%3D')[0].split('&').join('%26').split('=').join('%3D') + theme_arg;
						a.href += 'dummy_html' !== theme ? '%26time%3D' + Date.now() : '';
					}
					else{
						a.href = a.href.split('&theme=')[0].split('%26').join('&').split('%3D').join('=');
						a.href += 'dummy_html' !== theme ? '&time=' + Date.now() : '';
					}
					a.href = a.href.replace('%3Dhttps','=https').replace('%3Dhttp','=http');
					window.open(a.href,'_blank');
					a.href = first_href;
					eos_dpBody.removeClass('eos-test-in-progress');
					return true;
				}
				else{
					eos_dpBody.removeClass('eos-test-in-progress');
					alert( 'Something went wrong' );
				}
			}
		});
		return false;
	});
	

	$('.eos-dp-lock-post').on('click',function(){
		$(this).closest('tr').toggleClass('eos-post-locked');
	});





	$("#eos-dp-stop-process").on("click", function () {
		window.eos_dp_stop_process = true;
		$(this).addClass('eos-dp-not-active');
	});
	$(".eos-dp-pro-autosettings").on("click", function () {
		window.eos_dp_autosuggest_counter = 0;
		if('undefined' !== typeof(window.eos_dp_stop_process) && window.eos_dp_stop_process){
			window.eos_dp_stop_process = false;
			return;
		}
		$('#eos-dp-stop-process').removeClass('eos-dp-not-active');
		$('#eos-dp-autosuggest-msg').removeClass('eos-hidden');
		$('#eos-dp-autosuggest-msg-error').addClass('eos-hidden');
		var button = $(this),
			backend = 'undefined' !== typeof(eos_dp_js.page) && 'eos_dp_admin' === eos_dp_js.page,
			ajax_loader = $(this).next(".ajax-loader-img"),
			plugins= [],
			data = {
				"offset" : 0,
				"nonce" : backend ? $("#eos_dp_pro_auto_settings_admin").val() : $("#eos_dp_pro_auto_settings").val(),
				"action" : backend ? 'eos_dp_pro_auto_settings_admin' : 'eos_dp_pro_auto_settings'
			};
		$('.eos-dp-plugin-name').each(function(){
			plugins.push($(this).attr('data-path'));
		});
		data.plugins = plugins.join(',');
		if(backend){
			data.admin_page = button.closest('tr').find('.eos-dp-title').attr('href');
		}
		else{
			if('undefined' !== typeof(eos_dp_js.page) && 'eos_dp_by_archive' === eos_dp_js.page){
				data.post_type = button.closest('tr').attr('data-post-type');
			}
			else{
				data.post_id = button.closest('.eos-dp-actions').attr('data-post-id');
			}
		}
		window.eos_dp_row = button.closest('tr');
		ajax_loader.removeClass('eos-hidden').removeClass('eos-not-visible');		
		eos_dp_row.addClass('eos-test-in-progress');
		eos_dp_animate_checkboxes();
		button
			.addClass('eos-active-test')
			.closest('table').addClass('eos-dp-progress');
		$('.eos-dp-autochecked').removeClass('eos-dp-autochecked');
		eos_dp_send_autosuggest_request(button,data);
		return false;
	});




	if(psiButtons && psiButtons.length > 0){
		setInterval(function(){
			$.ajax({
				type : "POST",
				url : ajaxurl,
				data : {
					"nonce" : $("#eos_dp_key").val(),
					"action" : 'eos_dp_updated_key_for_preview'
				},
				success : function (response) {
					if('' !== response){
						var href = '';
						psiButtons.each(function(){
							href = this.href.split('%26eos_dp_preview%3D')[0];
							this.href = href + '%26eos_dp_preview%3D' + response;
						});
					}
				}
			});			
		},2000);
	}

});






function eos_dp_animate_checkboxes(){
	var	counter = 0,
	cols = eos_dp_row.find('td');
	cols
		.css('opacity','1')
		.removeClass('eos-dp-auto-checked')
	fdpCheckboxesInterval = setInterval(function(){
		jQuery('.eos-dp-name-th').removeClass('eos-dp-plugin-hover');
		jQuery('.eos-dp-name-th').eq(counter - 1).addClass('eos-dp-plugin-hover');
		cols.css('opacity','1')
		cols.eq(counter)
				.css('opacity','0.6')
		++counter;
		if(counter > cols.length) counter = 0;
	},100);
}
function eos_dp_stop_checkbox_animation(){
	if('undefined' !== typeof(fdpCheckboxesInterval) && 'undefined' !== typeof(eos_dp_row)){
		clearInterval(fdpCheckboxesInterval);
		eos_dp_row.find('td').addClass('eos-dp-auto-checked').css('opacity','1');
		jQuery('.eos-dp-name-th').removeClass('eos-dp-plugin-hover');
		delete eos_dp_row;
	}
}
function eos_dp_pro_check_suggestion_execution(){
	if('undefined' !== typeof(window.eos_dp_actual_row_in_progress)){
		if(jQuery('.eos-dp-post-row').length - window.eos_dp_actual_row_in_progress < 1){
			if('undefined' !== typeof(fdpCheckboxesInterval)){
				window.clearInterval(fdpCheckboxesInterval);
			}
			if('undefined' !== typeof(window.eos_dp_pro_suggest_allInterval)){
				window.clearInterval(eos_dp_pro_suggest_allInterval);
			}
			window.eos_dp_actual_row_in_progress = 0;		
		}
	}
}
function eos_dp_send_ajax( button,data ){
	var ajax_loader = button.next(".ajax-loader-img");
	ajax_loader.removeClass('eos-not-visible');
	jQuery.ajax({
		type : "POST",
		url : ajaxurl,
		data : data,
		success : function (response) {
			ajax_loader.addClass('eos-not-visible');
			if (parseInt(response) == 1) {
				jQuery('.eos-dp-opts-msg_success').removeClass('eos-hidden');
			} else {
				eos_dp_show_errors(response);
			}
		}
	});
}
function eos_dp_show_errors(response){
	if(response !== '0' && response !== ''){
		jQuery('.eos-dp-opts-msg_warning').text(response);
		jQuery('.eos-dp-opts-msg_warning').removeClass('eos-hidden');
	}
	else{
		jQuery('.eos-dp-opts-msg_failed').removeClass('eos-hidden');
	}
}
function eos_dp_send_autosuggest_request(button,data){
	jQuery.ajax({
		type : "POST",
		url : ajaxurl,
		data : data,
		success : function (response){
			++window.eos_dp_autosuggest_counter;
			if('' !== response){
				jQuery('#eos-dp-autosuggest-msg').addClass('eos-hidden');
				if('error' !== response){
					json = jQuery.parseJSON(response);
					var row = button.closest('.eos-dp-post-row'),
						path = '';
					row.find('input[type=checkbox]').filter(':visible').not('.eos-dp-global-chk-row').not('.eos-dp-lock-post').each(function(idx,el){
						if(idx + 1 > 4*(window.eos_dp_autosuggest_counter - 1) && idx < 4*(window.eos_dp_autosuggest_counter - 1) + 4 && idx < (jQuery('.eos-dp-name-th').length + 1)){
							chk = jQuery(this);
							path = jQuery('#eos-dp-plugin-name-' + (idx + 1)).attr('data-path');
							if(json.indexOf(path) > -1){
								chk
									.attr('checked',1)
									.closest('td').addClass('eos-dp-autochecked').removeClass('eos-dp-active').trigger('change')
							}
							else{
								chk
									.removeAttr('checked')
									.closest('td').addClass('eos-dp-autochecked').addClass('eos-dp-active').trigger('change')
							}
							chk.trigger('change');
						}
						
					});	
					if('undefined' !== typeof(eos_dp_js.page) && 'eos_dp_admin' === eos_dp_js.page){
						var row = button.closest('tr'),
							href = row.find('.eos-dp-title').attr('href');
						jQuery('a.eos-dp-title[href="' + href + '"]').each(function(){
							eos_dp_clone_row_options(row,jQuery(this).closest('tr'));
						});							
					}
					data.offset = 4*window.eos_dp_autosuggest_counter;
					if(parseInt(window.eos_dp_autosuggest_counter) < Math.ceil(jQuery('.eos-dp-name-th').length/4)){
						eos_dp_send_autosuggest_request(button,data);
					}
					else{
						eos_dp_stop_checkbox_animation();
						jQuery('.eos-dp-autochecked').removeClass('eos-dp-autochecked');
						button
							.closest('tr').removeClass('eos-test-in-progress')
							.removeClass('eos-active-test')
							.closest('table').removeClass('eos-dp-progress')
							.next(".ajax-loader-img").addClass('eos-hidden').addClass('eos-not-visible');
						
						row.addClass('eos-post-locked');
						if('undefined' !== typeof(window.eos_dp_actual_row_in_progress) && null !== window.eos_dp_actual_row_in_progress){
							++window.eos_dp_actual_row_in_progress;
							var nextBtn = 'eos_dp_admin' !== eos_dp_js.page ? row.next().find('.eos-dp-pro-autosettings') : row.nextAll('.eos-dp-admin-row').first().find('.eos-dp-pro-autosettings');
							if(nextBtn.length > 0){
								nextBtn.trigger('click');
							}
							else{
								window.eos_dp_actual_row_in_progress = null;
							}			
						}
												
						return false;
					}
					
				}
				else{
					jQuery('#eos-dp-autosuggest-msg-error').removeClass('eos-hidden');
					jQuery('.eos-dp-autochecked').removeClass('eos-dp-autochecked');
					eos_dp_stop_checkbox_animation();
					button
						.closest('tr').removeClass('eos-test-in-progress')
						.removeClass('eos-active-test')
						.closest('table').removeClass('eos-dp-progress')
						.next(".ajax-loader-img").addClass('eos-hidden').addClass('eos-not-visible');		
					return false;
				}
			}
		}
	});
}
function eos_dp_update_chk_wrp(chk,checked){
	if(true === checked){
		chk.parent().removeClass('eos-dp-active-wrp').addClass('eos-dp-not-active-wrp');
	}
	else{
		chk.parent().addClass('eos-dp-active-wrp').removeClass('eos-dp-not-active-wrp');
	}
}
function eos_dp_update_included_checks(el){
	var wrp = jQuery(el).closest('#eos-dp-plugins-wrp');
	var checks_imploder = wrp.find('.checkbox-result');
	var included_chk = [];
	var n = 0;
	wrp.find('.eos-theme-checkbox-div').each(function () {
		if (jQuery(this).find('input').prop('checked') === true) {
			included_chk[n] = jQuery(this).find('input').val();
			n = n + 1;
		}
	});
	checks_imploder.val(included_chk.sort().toString());
}		